"""health_clinic_is_01 URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/4.0/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.urls import path
from api.views import (
# driverView,
# getAllDriversView,newEntryTokenView,
# CreatePatientView,driverNewEntryView,
customerView, createCustomerView,smsView,createSMSView,smsGenerator,
createSMSViewV,smsGeneratorV,
)

urlpatterns = [
    #path('api/home', driverView.as_view()),

    path('api/home/getAllCustomers', customerView.as_view()),
    path('api/home/createNewCustomers', createCustomerView.as_view()),

    path('api/home/getAllSMS', smsView.as_view()),
    path('api/home/createNewSMS', createSMSView.as_view()),
    #path('api/home/createNewSMS', createSMSView.as_view()),
    path('api/smsGenerator/createSMSViewV,', createSMSViewV, name="createSMSViewV"),
    ###smsGeneratorV
    #####path('api/home/smsGeneratorV,', smsGeneratorV.as_view()),
    ###path('api/smsGenerator/smsGeneratorV,', smsGeneratorV, name="smsGeneratorV"),
    path('api/smsGenerator', smsGenerator),
    #path('api/home/createNewCustomers', views.createCustomerView.as_view()),

    # path('api/cpv', CreatePatientView.as_view()),
    # path('api/home/dnev', driverNewEntryView.as_view()),
    # path('api/home/netv', newEntryTokenView.as_view()),

    ##path('inventory/index', index),driverNewEntrySerializer
    ##path('inventory/userPanel', userPanel),
    ##serializer_class= PatientSerializer
    ##newEntryTokenView
]
