import datetime
from inventory.models import (
count_tokens, item_desc,view_v_item_desc_1,
account_category,account,expenses,
view_v_all_expenses_full_1,view_v_all_accounts_full_1
)
from django.db.models import Max
from inventory.general.general import general

gen=general()
class expensesC():
    expenses_init=''
        #return 0

    def loadExpensesReport008(self,_reportType,_dateFrom,_dateTo):
        xStr=self.loadExpensesReports008Data(_dateFrom, _dateTo)
        return xStr

    def loadExpensesReports008Data(self, _dateFrom, _dateTo):
        x=0
        iList=[]
        final_dict_list=[]
        inv_expenses=view_v_all_expenses_full_1.objects.values().filter(trans_date__gte=_dateFrom, trans_date__lte=_dateTo)

        inv_tokens_details=''
        tokensStr=''
        tokensStr+=''
        x=0
        allTotalCost=0
        for a in inv_expenses:
            y=0
            totalCost=a['amount']
            allTotalCost+=float(totalCost)
            myDict={
            "sno": x+1, "accountName":a['account_name'] ,"expensesDate":str(a['trans_date']),
            "amount": str(a['amount']), "details": a['details']
            }
            iList.append(myDict)

            x=x+1
        myDict={
        "sno": x+1, "accountName":"Total" ,"expensesDate":"",
        "amount": str(allTotalCost), "details": ""
        }
        iList.append(myDict)

        print(iList)
        return iList


    def loadExpensesReport009(self,_reportType,_dateFrom,_dateTo):
        xStr=self.loadExpensesReports009Data(_dateFrom, _dateTo)

        return xStr

    def loadExpensesReports009Data(self, _dateFrom, _dateTo):
        x=0
        iList=[]
        final_dict_list=[]
        inv_expenses=view_v_all_expenses_full_1.objects.values().filter(trans_date__gte=_dateFrom,trans_date__lte=_dateTo)
        inv_expenses_list=list(inv_expenses)
        inv_accounts=view_v_all_accounts_full_1.objects.values()
        inv_accounts_list=list(inv_accounts)
        tokensStr=''
        tokensStr+=''
        x=0
        allTotalCost=0
        qtyTotalUnit=0
        qtyTotalNotUnit=0
        qtyTotal=0
        qtyStr=''
        iList=[]
        for a in inv_accounts_list:
            qtyTotalUnit=0
            qtyTotalNotUnit=0
            qtyTotal=0
            qtyStr=''

            qtyTotal=sum([ b['amount'] for b in inv_expenses_list if b['account_id']==a['account_id'] ])
            #qtyStr='' + str(qtyTotal) + ' ' + a['uoq'] + '(s)'
            iList.append({ 'accountName': a['account_name'], 'amountTotal': str(qtyTotal) })

        print(iList)
        return iList

    def getItemUoqAndItemNames(self):
        inv=view_v_item_desc_with_uoq_1.objects.values()
        jStr='{"items":['
        y=0
        for a in inv:
            jStr+='{"itemDescId":"' + str(a['item_desc_id']) + '",'
            jStr+='"itemDescName":"' + a['desc_name'] + '",'
            jStr+='"itemUoq":"' + a['uoq'] + '",'
            jStr+='"itemSingleUnit":"' + str(a['single_unit']) + '"'
            if y+1>=len(inv):
                jStr+='}'
            else:
                jStr+='},'
            y=y+1
        jStr+=']}'
        return jStr

    def insertNewExpensesToDb(self, _accountId, _amount, _transDate, _details):
        inv=expenses(
        account=account.objects.get(id=_accountId),
        amount=_amount,
        trans_date=_transDate,
        bk_status='Active',
        details=_details
        )
        inv.save()
        return 'success'

    def saveNewExpenses(self, _accountName, _amount, _transDate, _details):
        accountId=0
        y=''
        _accountName=gen.removeWhiteSpaces(_accountName)
        accountId=self.getAccountId(_accountName)
        y=self.insertNewExpensesToDb(accountId, _amount, _transDate,_details)
        return y

    def getAccountId(self, _accountName):
        inv=account.objects.values().filter(name=_accountName, status='Active')
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['id']
            ##print('y1=' + str(y))
            ####
        else:
            y=y
        return y
