
from inventory.models import (
warehouse,warehouse_manager,supplier,customer,shop,
stock_requisition,stock_requisition_details,stock_balance_warehouse
)
from django.db.models import Max
from inventory.uoqFunctions import uoq
from inventory.warehouseFunctions import warehouses
from inventory.userCategoryFunctions import userCategories

class stockRequisition:

    def addToStockBalanceWarehouseFromSupplierToWarehouse(self, _itemId, _itemDescId, _uoq, _quantity, _dtpStockRequisitionDate, _requisitionId, _dataDict):

        newWarehouses=warehouses()
        warehouseId=0
        warehouseId=newWarehouses.getWarehouseId(_dataDict['destination'])##
        inv=stock_balance_warehouse(stock_requisition_id_id=_requisitionId,
        item_desc_id_id=_itemDescId, uoq=_uoq, quantity=_quantity,
        status='Pending Waiting For Approval',trans_status='IN', warehouse_id_id=warehouseId)
        inv.save()
        ###

    def searchForRequisition(self, _requisitionId):
        inv=stock_requisition.objects.values().filter(id=_requisitionId)
        inv_list=list(inv)
        inv_dict={
        'id': inv_list[0]['id'], 'category': inv_list[0]['category'],
        'requisition_date': inv_list[0]['stock_requisition_date'],
        'status': inv_list[0]['status'], 'origin': inv_list[0]['origin'],
        'destination': inv_list[0]['destination']
        }
        print("xxx=" + str(inv_dict['category']))
        return inv_dict
        ###

    def addNewStockRequisitionItems(self, _itemId, _itemDescId, _uoq, _quantity, _dtpStockRequisitionDate, _requisitionId):
        _requisitionId=int(_requisitionId)
        #print("type:::" + str(type(_requisitionId)))
        inv=stock_requisition_details(stock_requisition=_requisitionId,item_desc_id_id=_itemDescId, uoq=_uoq, quantity=_quantity,status='Pending Waiting For Req Approval')
        inv.save()
        print("type::")
        stockRequisitionDetailsId=stock_requisition_details.objects.values().aggregate(Max('id'))['id__max']
        ###
        a=0
        msg=self.searchForRequisition(_requisitionId)
        print("x=" + str(msg['category']))
        x=0
        if msg['category']=="From Supplier to Warehouse":
            self.addToStockBalanceWarehouseFromSupplierToWarehouse( _itemId, _itemDescId, _uoq, _quantity, _dtpStockRequisitionDate, _requisitionId, msg)
            x=0
            ###
        else:
            x=0
        #if msg.category==
        print("msg=" + str(msg))
        return msg
        ###
        ###


    def lookIfStockRequisitionExists(self,_requisitionCategory, _requisitionOrigin,_requisitionDestination, _dtpStockRequisitionDate):
        inv=stock_requisition.objects.values().filter(status='Active',category=_requisitionCategory,
        origin=_requisitionOrigin, destination=_requisitionDestination, stock_requisition_date=_dtpStockRequisitionDate)
        stockRequisitionId=0
        if len(list(inv))>0:
            stockRequisitionId=inv[0]['id']
        else:
            stockRequisitionId=stockRequisitionId
        return stockRequisitionId

        ##
        ###

    def addNewStockRequisition(self, _requisitionCategory, _requisitionOrigin,_requisitionDestination, _dtpStockRequisitionDate):
        if _requisitionCategory[0]==" ":
            _requisitionCategory=_requisitionCategory[1:len(_requisitionCategory)]

        if _requisitionOrigin[0]==" ":
            _requisitionOrigin=_requisitionOrigin[1:len(_requisitionOrigin)]

        if _requisitionDestination[0]==" ":
            _requisitionDestination=_requisitionDestination[1:len(_requisitionDestination)]
        stockRequisitionId=0
        msg=''
        stockRequisitionId=self.lookIfStockRequisitionExists(_requisitionCategory, _requisitionOrigin,_requisitionDestination, _dtpStockRequisitionDate)
        if stockRequisitionId<=0:
            inv=stock_requisition(category=_requisitionCategory,origin=_requisitionOrigin,
            destination=_requisitionDestination,stock_requisition_date=_dtpStockRequisitionDate, status='Active')
            inv.save()
            msg='Stock Requisition was successfully saved'
        else:
            stockRequisitionId=stockRequisitionId
            msg='Stock Requisition Already Exists'
        return msg
            ###

        ###

    def getAllDataToCreateStockRequisition(self):
        inv_warehouse=warehouse.objects.values().filter(status='Active').values_list('name')
        inv_supplier=supplier.objects.values().filter(status='Active').values_list('name')
        inv_customer=customer.objects.values().filter(status='Active').values_list('name')
        inv_shop=shop.objects.values().filter(status='Active').values_list('name')
        outputList=[]
        outputList.append({'warehouses': list(inv_warehouse)})
        outputList.append({'shops': list(inv_shop)})
        outputList.append({'customers': list(inv_customer)})
        outputList.append({'suppliers': list(inv_supplier)})
        return outputList

    #stockRequisitionList
