

class sideLinks():

    def getSingleLink(self, _linkIdName,_linkTopName, _linkTopIcons, linkChilds):
        linkStr=''
        linkStr+='''
          <li>
          <a data-toggle="collapse" href="#''' + _linkIdName + '''">
               <i class="material-icons">''' + _linkTopIcons + '''</i>
              <p>''' +  _linkTopName + '''
                  <b class="caret"></b>
               </p>
           </a>
           <div class="collapse" id="''' + _linkIdName + '''">
             <ul class="nav">'''
        for a in linkChilds:
            linkStr+=''' <li>
                  <a href="''' + a['url'] + '''"> <!-- -->
                          <span class="sidebar-mini"> </span>
                      <span class="sidebar-normal">''' + a['tagName'] + ''' </span>
                       </a>
                  </li>'''
        linkStr+='''
             </ul>
           </div>
        </li>'''
        return linkStr

    def getSingleLinkWithNoChild(self, _linkUrl,_linkTopName, _linkTopIcons):
        linkStr=''
        #<i class="material-icons">''' + _linkTopIcons + '''</i>
        linkStr+=''' <li>
                <a href="''' + _linkUrl + '''">
                        <span class="sidebar-normal">
                        <i class="material-icons">''' + _linkTopIcons + '''</i>
                        ''' + _linkTopName + '''
                        </span>
                    <!--<span class="sidebar-normal">''' +  ''' </span>-->
                     </a>
                </li>
        '''
        return linkStr


    def getSuppliersLinks(self):
        gLink=''
        linkChilds=[
        {'url': 'suppliersList', 'tagName':'Suppliers'}
        ]
        gLink=self.getSingleLink('suppliers','Suppliers', 'people', linkChilds)
        return gLink

    def getSalesLinks(self):
        gLink=''
        linkChilds=[
        {'url': 'posInv', 'tagName':'Sales POS'},
        {'url': 'salesReports', 'tagName':'Sales Reports'},
        {'url': 'salesList', 'tagName':'Sales List'},
        {'url': 'salesArchiveList', 'tagName':'Sales List Archive'},
        {'url': 'stockBalanceList', 'tagName':'Stock Balance List'}
        ]
        gLink=self.getSingleLink('sales','Sales', 'account_balance_wallet', linkChilds)
        return gLink

    def getPosInvExtSalesLinks(self):
        gLink=''
        linkChilds=[
        {'url': 'salesReports', 'tagName':'Sales Reports'},
        {'url': 'salesList', 'tagName':'Sales List'},
        {'url': 'salesArchiveList', 'tagName':'Sales List Archive'},
        {'url': 'stockBalanceList', 'tagName':'Stock Balance List'}
        ]
        gLink=self.getSingleLink('sales','Sales', 'account_balance_wallet', linkChilds)
        return gLink


    def getPurchasesLinks(self):
        gLink=''
        linkChilds=[
        {'url': 'purchasesList', 'tagName':'Purchases'},
        {'url': 'purchasesReports', 'tagName':'Purchases Reports'},
        {'url': 'purchasesArchiveList', 'tagName':'Purchases Archive'}
        ]
        gLink=self.getSingleLink('purchases','Purchases', 'shopping_cart', linkChilds)
        return gLink


    def getStockInToShopsLinks(self):
        gLink=''
        linkChilds=[
        {'url': 'stockInToShopsAdv', 'tagName':'Stock In To Shops'},
        {'url': 'stockInToShopsReports', 'tagName':'Stock In To Shops Reports'},
        {'url': 'stockInToShopsArchiveList', 'tagName':'Stock In To Shops Archive'}
        ]
        gLink=self.getSingleLink('stockInToShopsAdv','Stock In To Shops', 'shopping_cart', linkChilds)
        return gLink

    def getStockInToWarehousesLinks(self):
        gLink=''
        linkChilds=[
        {'url': 'stockInToWarehousesAdv', 'tagName':'Stock In To Warehouses'},
        {'url': 'stockInToWarehousesReports', 'tagName':'Stock In To Warehouses Reports'},
        {'url': 'stockInToWarehousesArchiveList', 'tagName':'Stock In To Warehouses Archive'}
        ]
        gLink=self.getSingleLink('stockInToWarehousesAdv','Stock In To Warehouses', 'shopping_cart', linkChilds)
        return gLink

    def getExpensesLinks(self):
        gLink=''
        linkChilds=[
        {'url': 'expensesList', 'tagName':'Expenses'},
        {'url': 'expensesReports', 'tagName':'Expenses Reports'}
        ]
        gLink=self.getSingleLink('expenses','Expenses', 'Money', linkChilds)
        return gLink

    def getSalesListLinks(self):
        gLink=''
        linkChilds=[
        {'url': 'salesList', 'tagName':'SalesList'}
        ]
        gLink=self.getSingleLink('salesList','Sales List', 'Money', linkChilds)
        return gLink

    def getSuppliersListLinks(self):
        gLink=''
        linkChilds=[
        {'url': 'suppliersList', 'tagName':'Suppliers'}
        ]
        gLink=self.getSingleLink('suppliersList','Suppliers', 'Money', linkChilds)
        return gLink

    def getPurchasesArchiveListLinks(self):
        gLink=''
        linkChilds=[
        {'url': 'purchasesArchiveList', 'tagName':'Purchases Archive List'}
        ]
        gLink=self.getSingleLink('purchasesArchiveList','Purchases Archive List', 'Money', linkChilds)
        return gLink

    def getSalesPriceListLinks(self):
        gLink=''
        linkChilds=[
        {'url': 'itemsSalesPriceList', 'tagName':'Items Sales Price'}
        ]
        gLink=self.getSingleLink('salesPriceList','Sales Price List', 'attach_money', linkChilds)
        return gLink

    def getShopsListLinks(self):
        gLink=''
        linkChilds=[
        {'url': 'shopsList', 'tagName':'Shops List'}
        ]
        gLink=self.getSingleLink('shopsList','Shops List', 'account_balance', linkChilds)
        return gLink

    def getUoqLinks(self):
        gLink=''
        linkChilds=[
        {'url': 'uoqList', 'tagName':'UOQ'}
        ]
        gLink=self.getSingleLink('uoq','UOQ', 'settings', linkChilds)
        return gLink

    def getUserPanelLinkWithNoChildren(self, _linkUrl,_linkTopName, _linkTopIcons):
        link=''
        link+=self.getSingleLinkWithNoChild( _linkUrl,_linkTopName, _linkTopIcons)
        return link

    def getTopUserPanelLinks(self):
        links=''
        links+=self.getSalesLinks()
        links+=self.getUoqLinks()
        links+=self.getPurchasesLinks()
        links+=self.getStockInToShopsLinks()
        links+=self.getExpensesLinks()
        links+=self.getSalesPriceListLinks()
        links+=self.getSuppliersListLinks()
        links+=self.getShopsListLinks()
        links+=self.getStockInToWarehousesLinks()
        #getSuppliersListLinks

        return links


    def getTopSuppliersLinks(self):
        links=''
        #links+=self.getTopUserPanelLinks()
        links+=self.getUserPanelLinkWithNoChildren('userPanel','User Panel', 'houseSiding')
        links+=self.getSalesLinks()
        links+=self.getPurchasesLinks()
        links+=self.getStockInToShopsLinks()
        links+=self.getExpensesLinks()
        links+=self.getUoqLinks()
        links+=self.getSalesPriceListLinks()
        links+=self.getShopsListLinks()
        links+=self.getStockInToWarehousesLinks()
        return links

    def getTopUOQLinks(self):
        links=''
        #links+=self.getTopUserPanelLinks()
        links+=self.getUserPanelLinkWithNoChildren('userPanel','User Panel', 'houseSiding')
        links+=self.getSalesLinks()
        links+=self.getPurchasesLinks()
        links+=self.getStockInToShopsLinks()
        links+=self.getExpensesLinks()
        links+=self.getSalesPriceListLinks()
        links+=self.getSuppliersListLinks()
        links+=self.getShopsListLinks()
        links+=self.getStockInToWarehousesLinks()
        return links

    def getTopSuppliersLinks2(self):
        links=''
        #links+=self.getTopUserPanelLinks()
        links+=self.getUserPanelLinkWithNoChildren('userPanel','User Panel', 'houseSiding')
        links+=self.getSalesLinks()
        links+=self.getPurchasesLinks()
        links+=self.getExpensesLinks()
        links+=self.getUoqLinks()
        return links

    def getTopPurchasesLinks(self):
        links=''
        #links+=self.getTopUserPanelLinks()
        links+=self.getUserPanelLinkWithNoChildren('userPanel','User Panel', 'houseSiding')
        links+=self.getSalesLinks()
        links+=self.getStockInToShopsLinks()
        links+=self.getExpensesLinks()
        links+=self.getUoqLinks()
        links+=self.getSalesPriceListLinks()
        links+=self.getSuppliersListLinks()
        links+=self.getShopsListLinks()
        links+=self.getStockInToWarehousesLinks()
        return links

    def getTopPosInvExt(self):
        links=''
        #links+=self.getTopUserPanelLinks()
        #links+=self.getUserPanelLinkWithNoChildren('userPanel','User Panel', 'houseSiding')
        links+=self.getPosInvExtSalesLinks()
        #links+=self.getStockInToShopsLinks()
        #links+=self.getExpensesLinks()
        #links+=self.getUoqLinks()
        #links+=self.getSalesPriceListLinks()
        #links+=self.getSuppliersListLinks()
        #links+=self.getShopsListLinks()
        #links+=self.getStockInToWarehousesLinks()
        return links

    def getTopPurchasesArchiveListLinks(self):
        links=''
        #links+=self.getTopUserPanelLinks()
        links+=self.getUserPanelLinkWithNoChildren('userPanel','User Panel', 'houseSiding')
        links+=self.getSalesLinks()
        links+=self.getStockInToShopsLinks()
        links+=self.getSuppliersLinks()
        links+=self.getExpensesLinks()
        links+=self.getUoqLinks()
        links+=self.getSalesPriceListLinks()
        links+=self.getShopsListLinks()
        links+=self.getStockInToWarehousesLinks()
        return links


    def getTopExpensesLinks(self):
        links=''
        #links+=self.getTopUserPanelLinks()
        links+=self.getUserPanelLinkWithNoChildren('userPanel','User Panel', 'houseSiding')
        links+=self.getSalesLinks()
        links+=self.getPurchasesLinks()
        links+=self.getStockInToShopsLinks()
        links+=self.getSuppliersLinks()
        links+=self.getUoqLinks()
        links+=self.getSalesPriceListLinks()
        links+=self.getSuppliersListLinks()
        links+=self.getShopsListLinks()
        links+=self.getStockInToWarehousesLinks()
        return links

    def getTopSalesListLinks(self):
        links=''
        #links+=self.getTopUserPanelLinks()
        links+=self.getUserPanelLinkWithNoChildren('userPanel','User Panel', 'houseSiding')
        links+=self.getExpensesLinks()
        links+=self.getPurchasesLinks()
        links+=self.getStockInToShopsLinks()
        links+=self.getUoqLinks()
        links+=self.getSalesPriceListLinks()
        links+=self.getSuppliersListLinks()
        links+=self.getShopsListLinks()
        links+=self.getStockInToWarehousesLinks()
        return links

    def getTopShopsListLinks(self):
        links=''
        #links+=self.getTopUserPanelLinks()
        links+=self.getUserPanelLinkWithNoChildren('userPanel','User Panel', 'houseSiding')
        links+=self.getExpensesLinks()
        links+=self.getPurchasesLinks()
        links+=self.getStockInToShopsLinks()
        links+=self.getUoqLinks()
        links+=self.getSalesPriceListLinks()
        links+=self.getSuppliersListLinks()
        links+=self.getStockInToWarehousesLinks()
        return links

    def getTopStockInToShopsListLinks(self):
        links=''
        links+=self.getUserPanelLinkWithNoChildren('userPanel','User Panel', 'houseSiding')
        links+=self.getExpensesLinks()
        links+=self.getPurchasesLinks()
        links+=self.getUoqLinks()
        links+=self.getSalesPriceListLinks()
        links+=self.getSuppliersListLinks()
        links+=self.getShopsListLinks()
        links+=self.getStockInToWarehousesLinks()
        return links

    def getTopStockInToWarehousesListLinks(self):
        links=''
        links+=self.getUserPanelLinkWithNoChildren('userPanel','User Panel', 'houseSiding')
        links+=self.getExpensesLinks()
        links+=self.getPurchasesLinks()
        links+=self.getStockInToShopsLinks()
        links+=self.getUoqLinks()
        links+=self.getSalesPriceListLinks()
        links+=self.getShopsListLinks()
        links+=self.getSuppliersListLinks()
        return links


    def getTopReportsFilterLinks(self):
        links=''
        links+=self.getUserPanelLinkWithNoChildren('userPanel','User Panel', 'houseSiding')
        links+=self.getExpensesLinks()
        links+=self.getPurchasesLinks()
        links+=self.getStockInToShopsLinks()
        links+=self.getUoqLinks()
        links+=self.getSalesPriceListLinks()
        links+=self.getShopsListLinks()
        links+=self.getStockInToWarehousesLinks()
        links+=self.getSuppliersListLinks()
        return links

    def getTopSuppliersListLinks(self):
        links=''
        #links+=self.getTopUserPanelLinks()
        links+=self.getUserPanelLinkWithNoChildren('userPanel','User Panel', 'houseSiding')
        links+=self.getExpensesLinks()
        links+=self.getPurchasesLinks()
        links+=self.getStockInToShopsLinks()
        links+=self.getSuppliersLinks()
        links+=self.getUoqLinks()
        links+=self.getSalesPriceListLinks()
        links+=self.getShopsListLinks()
        return links

    def getTopSalesPriceLinks(self):
        links=''
        #links+=self.getTopUserPanelLinks()
        links+=self.getUserPanelLinkWithNoChildren('userPanel','User Panel', 'houseSiding')
        links+=self.getSalesLinks()
        links+=self.getExpensesLinks()
        links+=self.getPurchasesLinks()
        links+=self.getStockInToShopsLinks()
        links+=self.getUoqLinks()
        links+=self.getSuppliersListLinks()
        links+=self.getShopsListLinks()
        return links

    def getLinks(self,_pageName):
        links=''
        if _pageName=="userPanel":
            links=self.getTopUserPanelLinks()
        elif _pageName=="UOQ":
            links=self.getTopUOQLinks()
        elif _pageName=="Purchases":
            links=self.getTopPurchasesLinks()
        elif _pageName=="SalesList":
            links=self.getTopSalesListLinks()
        elif _pageName=="PurchasesArchiveList":
            links=self.getTopPurchasesArchiveListLinks()
        elif _pageName=="Expenses":
            links=self.getTopExpensesLinks()
        elif _pageName=="Suppliers":
            links=self.getTopSuppliersLinks()
        elif _pageName=="itemsSalesPriceList":
            links=self.getTopSalesPriceLinks()
        elif _pageName=="SuppliersList":
            links=self.getTopSuppliersListLinks()
        elif _pageName=="ShopsList":
            links=self.getTopShopsListLinks()
        elif _pageName=="StockInToShops":
            links=self.getTopStockInToShopsListLinks()
        elif _pageName=="StockInToWarehouses":
            links=self.getTopStockInToWarehousesListLinks()
        elif _pageName=="ReportsFilter":
            links=self.getTopReportsFilterLinks()
        elif _pageName=="posInvExt":
            links=self.getTopPosInvExt()
        else:
            links=''
        return links
