import datetime
from inventory.models import (
item,item_size,item_brand,item_desc,inv_no_settings,
item_inv_no_settings,qty_measure,qty_measure_data,item_measures,
purchase_batch,purchases_store,
t_purchases,purchases_details,batch_count,supplier,
view_v_item_qty_33_1_c,view_v_purchases_full_1,view_v_item_desc_with_uoq_1,
stock_in_to_shop_details,shop,view_v_all_stock_in_to_warehouses_1_a,
view_v_all_stock_in_to_shops_1_a,warehouse_inv,stock_in_to_warehouse_details,

ext_category,item_ext_category,item_desc_ext_category,
view_v_item_desc_with_ext_category_01,
order_from_supplier,

)
from django.db.models import Max
from inventory.uoqFunctions import uoq
from inventory.userCategoryFunctions import userCategories
from inventory.general.general import general


gen=general()

class purchases:

    def loadStockInToWarehousesReport008(self,_reportType,_dateFrom,_dateTo,warehouseName):
        xStr=self.loadStockInToWarehousesReports008Data(_dateFrom, _dateTo, warehouseName)

        return xStr

    def loadStockInToWarehousesReports008Data(self, _dateFrom, _dateTo,warehouseName):
        x=0
        iList=[]
        final_dict_list=[]
        inv_stockintowarehouses=view_v_all_stock_in_to_warehouses_1_a.objects.values().filter(stock_in_date__gte=_dateFrom,stock_in_date__lte=_dateTo,warehouse_name=warehouseName,status="Active")

        inv_tokens_details=''
        tokensStr=''
        tokensStr+=''
        x=0
        allTotalCost=0
        for a in inv_stockintowarehouses:
            y=0
            myDict={
            "sno": x+1,
            "descName":a['desc_name'] , "stockInDate":str(a['stock_in_date']),
            "quantity": str(a['quantity']),"uoq": a['uoq'],
            "warehouseName": str(a['warehouse_name'])
            }
            iList.append(myDict)
            x=x+1

        return iList


    def loadStockInToShopsReport008(self,_reportType,_dateFrom,_dateTo,shopName):
        xStr=self.loadStockInToShopsReports008Data(_dateFrom, _dateTo, shopName)

        return xStr

    def loadStockInToShopsReports008Data(self, _dateFrom, _dateTo,shopName):
        x=0
        iList=[]
        final_dict_list=[]
        inv_stockintoshops=view_v_all_stock_in_to_shops_1_a.objects.values().filter(stock_in_date__gte=_dateFrom,stock_in_date__lte=_dateTo,shop_name=shopName,status="Active")

        inv_tokens_details=''
        tokensStr=''
        tokensStr+=''
        x=0
        allTotalCost=0
        for a in inv_stockintoshops:
            y=0
            myDict={
            "sno": x+1,
            "descName":a['desc_name'] , "stockInDate":str(a['stock_in_date']),
            "quantity": str(a['quantity']),"uoq": a['uoq'],
            "shopName": str(a['shop_name'])
            }
            iList.append(myDict)
            x=x+1

        return iList


    def loadPurchasesArchive008(self,_dateFrom,_dateTo):
        xStr=self.loadPurchasesArchive008Data(_dateFrom, _dateTo)

        return xStr

    def loadPurchasesReport008(self,_reportType,_dateFrom,_dateTo):
        xStr=self.loadPurchasesReports008Data(_dateFrom, _dateTo)

        return xStr

    def loadPurchasesReports008Data(self, _dateFrom, _dateTo):
        x=0
        iList=[]
        final_dict_list=[]
        inv_purchases=view_v_purchases_full_1.objects.values().filter(purchases_date__gte=_dateFrom,purchases_date__lte=_dateTo)

        inv_tokens_details=''
        tokensStr=''
        tokensStr+=''
        x=0
        allTotalCost=0
        for a in inv_purchases:
            y=0
            totalCost=a['total_price']
            allTotalCost+=float(totalCost)
            myDict={
            "sno": x+1, "itemName":a['item_name'] ,
            "descName":a['desc_name'] ,"purchasesDate":str(a['purchases_date']),
            "unitPrice": str(a['unit_price']),"quantity": str(a['quantity']),"uoq": a['uoq'],
            "totalCost": str(a['total_price'])
            }
            iList.append(myDict)

            x=x+1
        myDict={
        "sno": x+1, "itemName": "Total",
        "descName": "", "purchasesDate": "",
        "unitPrice": "", "quantity": "","uoq": "",
        "totalCost": str(allTotalCost)
        }
        iList.append(myDict)

        return iList


    def loadPurchasesArchive008Data(self, _dateFrom, _dateTo):
        x=0
        iList=[]
        final_dict_list=[]
        inv_purchases=view_v_purchases_full_1.objects.values().filter(purchases_date__gte=_dateFrom,purchases_date__lte=_dateTo)

        inv_tokens_details=''
        tokensStr=''
        tokensStr+=''
        x=0
        allTotalCost=0
        for a in inv_purchases:
            y=0
            totalCost=a['total_price']
            allTotalCost+=float(totalCost)
            myDict={
            "sno": x+1, "itemName":a['item_name'] ,
            "descName":a['desc_name'] ,"purchasesDate":str(a['purchases_date']),
            "unitPrice": str(a['unit_price']),"quantity": str(a['quantity']),"uoq": a['uoq'],
            "totalCost": str(a['total_price'])
            }
            iList.append(myDict)

            x=x+1
        myDict={
        "sno": x+1, "itemName": "Total",
        "descName": "", "purchasesDate": "",
        "unitPrice": "", "quantity": "","uoq": "",
        "totalCost": str(allTotalCost)
        }
        iList.append(myDict)

        return iList


    def loadPurchasesReport009(self,_reportType,_dateFrom,_dateTo):
        xStr=self.loadPurchasesReports009Data(_dateFrom, _dateTo)

        return xStr

    def loadPurchasesReports009Data(self, _dateFrom, _dateTo):
        x=0
        iList=[]
        final_dict_list=[]
        inv_purchases=view_v_purchases_full_1.objects.values().filter(purchases_date__gte=_dateFrom,purchases_date__lte=_dateTo)
        inv_purchases_list=list(inv_purchases)
        inv_items=view_v_item_desc_with_uoq_1.objects.values()
        inv_items_list=list(inv_items)
        tokensStr=''
        tokensStr+=''
        x=0
        allTotalCost=0
        qtyTotalUnit=0
        qtyTotalNotUnit=0
        qtyTotal=0
        qtyStr=''
        iList=[]
        for a in inv_items_list:
            qtyTotalUnit=0
            qtyTotalNotUnit=0
            qtyTotal=0
            qtyStr=''
            if a['single_unit']>1:
                qtyTotalUnit=sum([ b['quantity'] for b in inv_purchases_list if b['item_desc_id']==a['item_desc_id'] and b['uoq']=="unit"])
                qtyTotalNotUnit=sum([ b['quantity'] for b in inv_purchases_list if b['item_desc_id']==a['item_desc_id'] and b['uoq']!="unit"])
                qtyStr=str(int(((qtyTotalUnit)+((qtyTotalNotUnit*a['single_unit'])))/(a['single_unit']))) + ' ' + a['uoq'] + '(s)'
                qtyStr+=' and ' + str(int(((qtyTotalUnit)+((qtyTotalNotUnit*a['single_unit'])))%(a['single_unit']))) + ' unit(s)'
            else:
                qtyTotal=sum([ b['quantity'] for b in inv_purchases_list if b['item_desc_id']==a['item_desc_id'] and b['uoq']=="unit"])
                qtyStr='' + str(qtyTotal) + ' ' + a['uoq'] + '(s)'
            iList.append({'itemName': a['item_name'],'descName': a['desc_name'], 'qtyTotal': str(qtyTotal), 'qtyStr':qtyStr})

        return iList

    def insertIntoPurchasesBatch(self,_supplierId, _batchDate, _batchNumber):
        inv=purchase_batch(supplier_id_id=_supplierId, batch_number=_batchNumber,
        batch_date=_batchDate, status='Active')
        inv.save()

    def addNewPurchasesBatch(self, _supplierName, _batchDate, _batchNumber):

        _supplierName=gen.removeWhiteSpaces(_supplierName)
        supplierId=0
        newUserCategories=userCategories()
        supplierId=newUserCategories.getSupplierId(_supplierName)
        self.insertIntoPurchasesBatch(supplierId, _batchDate, _batchNumber)
        msg='Batch was successfully Added'
        return msg
        ###
    def getTodayDate(self):
        todayDate=datetime.date.today()
        todayYear=str(datetime.date.today().year)
        todayMonth=str(datetime.date.today().month)
        todayDay=str(datetime.date.today().day)
        if len(todayMonth)==1:
            todayMonth='0' + todayMonth
        if len(todayDay)==1:
            todayDay='0' + todayDay

        todayDateStr= todayYear + '-' + todayMonth + '-' + todayDay
        return todayDateStr

    def getTodayTime(self):
        todayTime=datetime.datetime.now()
        todayHour=str(datetime.datetime.now().hour)
        todayMinute=str(datetime.datetime.now().minute)
        todaySecond=str(datetime.datetime.now().second)

        todayTimeStr= todayHour + ':' + todayMinute + ':' + todaySecond + '.000000'
        return todayTimeStr

    def lookIfBatchYearExists(self,_batchYear):
        inv=batch_count.objects.values().filter(batch_year=_batchYear)
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['id']
            ####
        else:
            y=y
        return y
        ###www
    def insertIntoBatchCount(self,_batchYear):
        inv=batch_count(counter=1, batch_year=_batchYear, status='Active')
        inv.save()
        batchCountId=0
        #batchCountId=batch
        #batchCountId=batch_count.objects.values().aggregate(Max('id'))['id__max']
        return batchCountId
        ###rrr
    def createBatchNumber(self, _batchCountNumber, _supplierName, _batchDate):
        batchNumber=''
        batchIntStr= str(_batchCountNumber + 1)
        if len(batchIntStr)==1:
            batchIntStr='0000' + batchIntStr
        elif len(batchIntStr)==2:
            batchIntStr='000' + batchIntStr
        elif len(batchIntStr)==3:
            batchIntStr='00' + batchIntStr
        elif len(batchIntStr)==4:
            batchIntStr='0' + batchIntStr
        else:
            batchIntStr='' + batchIntStr
        batchDate=''

        batchDateOnly=''
        batchNumber=str(_batchDate)[0:4] + _supplierName[0:3].upper() + str(_batchDate)[5:7] + str(_batchDate)[8:10]  + batchIntStr
        return batchNumber #

    def updateBatchCount(self, _batchCountNumber, _batchDate):
        _batchCountNumber+=1
        inv=batch_count.objects.filter(batch_year=str(_batchDate)[0:4], status='Active').update(counter=_batchCountNumber)
        ###ccc
    def getBatchCounter(self, _batchYear):
        inv=batch_count.objects.values().filter(batch_year=_batchYear, status='Active')
        x=0
        x=list(inv)
        y=x[0]['counter']
        return y

    def getBatchNumber(self, _supplierName, _batchDate):
        if _supplierName[0]==' ':
            _supplierName=_supplierName[1:len(_supplierName)]
        batchYear=str(_batchDate)[0:4]
        x=0
        batchNumber=''
        batchCountId=0
        batchCountNumber=1
        batchCountId=self.lookIfBatchYearExists(batchYear)
        if batchCountId>0:
            batchCountId=batchCountId
            batchCountNumber=self.getBatchCounter(batchYear)
            ###
        else:
            batchCountId=self.insertIntoBatchCount(batchYear)
            ###
        self.updateBatchCount(batchCountNumber, _batchDate)
        batchNumber=self.createBatchNumber(batchCountNumber, _supplierName, _batchDate)
        #return _batchDate
        return batchNumber
        ###

    def addPuchasesMultipleToDb(self,_itemDescId,_purchasesId,_itemQuantity,_itemUnitPrice,_itemUOQ):
        inv=purchases_details(item_desc_id_id=_itemDescId,purchases_id_id=_purchasesId,quantity=_itemQuantity,
        unit_price=_itemUnitPrice,uoq=_itemUOQ,status='Active')
        inv.save()
        inv_=purchases_store(item_desc_id_id=_itemDescId,purchases_id_id=_purchasesId,quantity=_itemQuantity,
        unit_price=_itemUnitPrice,uoq=_itemUOQ,status='IN', category="PURCHASES")
        inv_.save()
        print("o neil")

        return 'Purchases was successful'

    def addPurchasesMultiple(self,_itemId,_itemDescId,_itemUnitPrice,_itemQuantity,_itemUOQ,_dtpPurchasesDate,_batchNumber):
        id=0
        print('hio')
        msg=''
        id=self.insertToPurchases(_dtpPurchasesDate,_batchNumber)
        msg=self.addPuchasesMultipleToDb(_itemDescId,id,_itemQuantity,_itemUnitPrice,_itemUOQ)
        ###
        return 'Purchase was successfully Saved'

    def insertToPurchases(self,_dtpPurchasesDate,_batchNumber):
        inv=t_purchases(status='Active',date_and_time=_dtpPurchasesDate, batch_no=_batchNumber)
        inv.save()
        x=0
        y=t_purchases.objects.values().aggregate(Max('id'))['id__max']
        return y
        #www

    def lookForItemBrandInItemDesc(self,_itemBrand,_itemName,_itemSize):
        ##print("3:::_itemSize=" + str(_itemSize))
        sizeId=self.getItemSizeFromDb(_itemSize)
        brandId=self.getItemBrandFromDb(_itemBrand)
        myUoq=uoq()
        itemId=myUoq.getItemId(_itemName)
        y=0
        inv=item_desc.objects.values().filter(item_id_id=itemId,item_brand_id_id=brandId,item_size_id_id=sizeId)
        #.values_list('id')

        x=len(list(inv))
        #print('x 1=' + str(x))
        y=0
        if x==0:
            print("NEW ITEM DESC")
            print ('item_name=' + str(_itemName) + ' : item_id:' + str(itemId) + ' , brand_id:' + str(brandId) + ' , size_id:' + str(sizeId))
            inv=item_desc(item_id_id=itemId,item_brand_id_id=brandId,status='Active',item_size_id_id=sizeId)
            inv.save()
            y=item_desc.objects.values().aggregate(Max('id'))['id__max']
            #y=self.insertIntoDbItemBrand(_itemBrand)
            #
        else:
            print("OLD ITEM DESC")
            y=inv[0]['id']
            #y=self.getItemBrandFromDb(_itemBrand)
            #
        return y

    def insertItemBrandIntoItemDesc___(self,_itemModel,_itemName):
        y=0
        #look if itembrand exists in itemdesc
        #inv=item_desc(status='Active',item_id_id=_itemModel,brand_id_id=)
        #inv.save()
        #x=0
        #y=item_brand.objects.values().aggregate(Max('id'))['id__max']
        return y
        #

    def insertItemBrandAndSizeIntoItemDesc(self,_itemModel,_itemName,_itemSize):
        y=0
        y=self.lookForItemBrandInItemDesc(_itemModel,_itemName,_itemSize)
        return y
        #

    def insertIntoDbItemBrand(self,_itemModel):
        inv=item_brand(status='Active',name=_itemModel)
        inv.save()
        x=0
        y=item_brand.objects.values().aggregate(Max('id'))['id__max']
        return y
        #

    def getItemBrandFromDb(self,_itemModel):
        x=0
        y=item_brand.objects.values().filter(name=_itemModel,status='Active')
        #.values_list('id')
        z=y[0]['id']
        #print('brand id=' + str(z))
        #(Max('id'))['id__max']
        return z
        #

    def lookForItemBrand(self,_itemBrand,_itemName):
        inv=item_brand.objects.values().filter(name=_itemBrand).values_list('id')
        #print('inv:' + str(inv))
        x=len(list(inv))
        #print('x=' + str(x))
        y=0
        if x==0:
            y=self.insertIntoDbItemBrand(_itemBrand)
            #
        else:
            y=self.getItemBrandFromDb(_itemBrand)
            #


    def insertIntoItemBrand(self,_itemName,_itemModel):
        self.lookForItemBrand(_itemModel,_itemName)
        #look if ItemBrandExists
        myUoq=uoq()
        itemId=myUoq.getItemId(_itemName)
        inv=''


    def lookForItemSize(self,_itemSize,_itemName):
        inv=item_size.objects.values().filter(name=_itemSize).values_list('id')
        #print('inv:' + str(inv))
        x=len(list(inv))
        #print('x=' + str(x))
        y=0
        if x==0:
            y=self.insertIntoDbItemSize(_itemSize)
            #
        else:
            y=self.getItemSizeFromDb(_itemSize)
            #xxx

    def getItemSizeFromDb(self,_itemSize):
        #print("4:::_itemSize=" + str(_itemSize))
        x=0
        y=item_size.objects.values().filter(name=_itemSize,status='Active')
        #.values_list('id')

        z=y[0]['id']
        #print("5:::z=" + str(z))
        #(Max('id'))['id__max']
        return z
        #
    def getExtCategoryIdFromDb(self,_itemCat):
        #print("4:::_itemSize=" + str(_itemSize))
        x=0
        y=ext_category.objects.values().filter(name=_itemCat,status='Active')
        #.values_list('id')

        z=y[0]['id']
        #print("5:::z=" + str(z))
        #(Max('id'))['id__max']

        return z

    def insertIntoItemDescExtCategory(self, catId, itemDescId):
        inv=item_desc_ext_category(
        ext_category=ext_category.objects.get(id=catId),
        item_desc=item_desc.objects.get(id=itemDescId),
        status='Active')
        inv.save()
        y=item_desc_ext_category.objects.values().filter(ext_category_id=catId,
        item_desc=itemDescId,status='Active')
        x=0
        z=0
        x=len(y)
        if x>0:
            z=y[0]['id']
        return z

    def getItemDescExtCategoryIdFromDb(self,extCategoryId,itemDescId):
        #print("4:::_itemSize=" + str(_itemSize))
        x=0
        y=item_desc_ext_category.objects.values().filter(ext_category_id=extCategoryId,
        item_desc=itemDescId,status='Active')
        #.values_list('id')
        x=len(y)
        z=0
        if x>0:
            z=y[0]['id']
            ###
        else:
            z=self.insertIntoItemDescExtCategory(extCategoryId, itemDescId)
            ###
        return z

        #print("5:::z=" + str(z))
        #(Max('id'))['id__max']
        return z

    def getItemDescIdFromDbWRONG(self,_itemName):
        #print("4:::_itemSize=" + str(_itemSize))
        x=0
        y=item_desc.objects.values().filter(name=_itemName,status='Active')
        #.values_list('id')

        z=y[0]['id']
        #print("5:::z=" + str(z))
        #(Max('id'))['id__max']
        return z

    def getItemExtCategoryIdFromDb(self,_itemName):
        #print("4:::_itemSize=" + str(_itemSize))
        x=0
        y=item_ext_category.objects.values().filter(name=_itemName,status='Active')
        #.values_list('id')

        z=y[0]['id']
        #print("5:::z=" + str(z))
        #(Max('id'))['id__max']
        return z
        #

    def getPurchasesStoreId(self,_purchasesId):
        x=0
        y=purchases_store.objects.values().filter(purchases_id_id=_purchasesId,status='IN')
        #.values_list('id')
        z=y[0]['id']
        #(Max('id'))['id__max']
        return z
        #

    def insertIntoDbItemSize(self,_itemSize):
        inv=item_size(status='Active',name=_itemSize)
        inv.save()
        x=0
        y=item_size.objects.values().aggregate(Max('id'))['id__max']
        return y
        #
    def insertIntoItemSize(self,_itemName,_itemSize):
        self.lookForItemSize(_itemSize,_itemName)
        #look if ItemBrandExists
        ##yyy

    def lookIfItemStoredInPurchasesStore(self, _purchasesId):
        z=0
        y=purchases_store.objects.values().filter(purchases_id_id=_purchasesId,status='IN')
        #.values_list('id')
        if len(y)>0:
            z=y[0]['id']
        #(Max('id'))['id__max']
        return z


    def insertToPurchasesDetails(self,_itemName,_itemModel,_itemSpecs,_itemQuantity,_itemUOQ,_itemUnitPrice,_purchasesId):
        y=0
        self.insertIntoItemBrand(_itemName,_itemModel)
        self.insertIntoItemSize(_itemName,_itemSpecs)
        itemDescId=self.insertItemBrandAndSizeIntoItemDesc(_itemModel,_itemName,_itemSpecs)

        inv_=purchases_store(item_desc_id_id=itemDescId,purchases_id_id=_purchasesId,quantity=_itemQuantity,
        unit_price=_itemUnitPrice,uoq=_itemUOQ,status='IN', category="PURCHASES")
        inv_.save()

        inv=purchases_details(item_desc_id_id=itemDescId,purchases_id_id=_purchasesId,quantity=_itemQuantity,
        unit_price=_itemUnitPrice,uoq=_itemUOQ,status='Active')
        inv.save()
        z=0
        _status=False
        while _status==False:
            z=self.lookIfItemStoredInPurchasesStore( _purchasesId)
            if z>0:
                _status=True

        print(str(":::STATUS STATUS:::"))
        return 'Purchases was successful'
        #inv=purchases_details(_itemName,_itemModel,_itemSpecs,_itemQuantity,_itemUOQ,_itemUnitPrice)
        #zzz

    def addNewPurchases(self,_itemName,_itemModel,_itemSpecs,_itemQuantity,_itemUOQ,_itemUnitPrice,_dtpPurchasesDate, _batchNumber):
        id=0
        _itemName=gen.removeWhiteSpaces(_itemName)
        _batchNumber=gen.removeWhiteSpaces(_batchNumber)

        id=self.insertToPurchases(_dtpPurchasesDate,_batchNumber)
        self.insertToPurchasesDetails(_itemName,_itemModel,_itemSpecs,_itemQuantity,_itemUOQ,_itemUnitPrice,id)
        ###
        return 'Purchase was successfully Saved'


    def postEditPurchases(self,_itemName,_itemModel,_itemSpecs,_itemQuantity,_itemUOQ,_itemUnitPrice, _purchasesId):
        id=0
        _itemName=gen.removeWhiteSpaces(_itemName)
        _itemModel=gen.removeWhiteSpaces(_itemModel)
        _itemSpecs=gen.removeWhiteSpaces(_itemSpecs)
        _itemUOQ=gen.removeWhiteSpaces(_itemUOQ)
        y=0
        self.insertIntoItemBrand(_itemName,_itemModel)
        self.insertIntoItemSize(_itemName,_itemSpecs)
        itemDescId=self.insertItemBrandAndSizeIntoItemDesc(_itemModel,_itemName,_itemSpecs)
        print("'" + str(itemDescId) + "'")
        inv=purchases_details.objects.filter(purchases_id_id=_purchasesId).update(item_desc_id_id=itemDescId,quantity=_itemQuantity,
        unit_price=_itemUnitPrice,uoq=_itemUOQ,status='Active')
        inv_=purchases_store.objects.filter(purchases_id_id=_purchasesId,category="PURCHASES").update(item_desc_id_id=itemDescId,quantity=_itemQuantity,
        unit_price=_itemUnitPrice,uoq=_itemUOQ,status='IN')
        return 'Purchases was successful edited'


    def postEditStockInToWarehouses(self,itemQuantity,sitsId):
        id=0
        inv=stock_in_to_warehouse_details.objects.filter(id=sitsId).update(quantity=itemQuantity)

        inv_=purchases_store.objects.filter(purchases_id_id=sitsId, category="WAREHOUSE").update(quantity=itemQuantity)
        return 'Stock In To Warehouse was successful edited'

    def postDeleteStockInToWarehouses(self,itemQuantity,sitsId):
        id=0
        inv=stock_in_to_warehouse_details.objects.get(
        id=sitsId)#.delete()
        inv.delete()
        #inv=stock_in_to_shop_details.objects.filter(id=sitsId).update(quantity=itemQuantity)

        inv_=purchases_store.objects.get(purchases_id_id=sitsId, category="WAREHOUSE")
        inv_.delete() #.update(quantity=itemQuantity)
        return 'Stock In To Warehouse was successful deleted'

    def getStockInToWarehouseIdFromSitsId(self, sitsId):
        _id=0
        #stock_in_to_warehouse_details
        y=stock_in_to_warehouse_details.objects.values().filter(stock_in_to_shop_details_id_id=sitsId,status='OUT')
        sitsList=list(y)
        x=0
        x=len(sitsList)
        z=0
        if x>0:
            z=y[0]['id']
            ###
        else:
            z=0
            ###
        return z


    def postEditStockInToShops(self,itemQuantity,sitsId):
        id=0
        inv=stock_in_to_shop_details.objects.filter(id=sitsId).update(quantity=itemQuantity)
        x=0
        x=self.getStockInToWarehouseIdFromSitsId(sitsId)
        if x<=0:
            inv_=purchases_store.objects.filter(purchases_id_id=sitsId,category="STOCK IN TO SHOPS").update(quantity=itemQuantity)
            ###
        else:
            inv_=stock_in_to_warehouse_details.objects.filter(stock_in_to_shop_details_id_id=sitsId).update(quantity=itemQuantity)
            ###

        return 'Stock In To Shop was successful edited'

    def postDeleteStockInToShops(self,itemQuantity,sitsId):
        id=0
        inv=stock_in_to_shop_details.objects.get(
        id=sitsId)#.delete()
        inv.delete()
        #inv=stock_in_to_shop_details.objects.filter(id=sitsId).update(quantity=itemQuantity)
        x=self.getStockInToWarehouseIdFromSitsId(sitsId)
        if x<=0:
            inv_=purchases_store.objects.get(purchases_id_id=sitsId,category="STOCK IN TO SHOPS")
            inv_.delete()
            ###
        else:
            inv_=stock_in_to_warehouse_details.objects.get(stock_in_to_shop_details_id_id=sitsId)
            inv_.delete()
            ###

        # inv_=purchases_store.objects.get(purchases_id_id=sitsId,category="STOCK IN TO SHOPS")
        # inv_.delete() #.update(quantity=itemQuantity)
        return 'Stock In To Shop was successful deleted'

    def postDeletePurchases(self, _purchasesId):
        _id=0
        inv=purchases_details.objects.get(
        id=_purchasesId)#.delete()
        inv.delete()
        print("puchases:::" + str(_purchasesId))

        _id=self.getPurchasesStoreId(_purchasesId)
        print("id:::" + str(_id))
        inv=purchases_store.objects.get(
        id=_id)#.delete()
        inv.delete()

        return 'Purchases was successful deleted'
        ###APPROVAL


    def getItemUoq02(self, _itemName):
        _itemName=gen.removeWhiteSpaces(_itemName)

        itemUOQ=''
        print("itemname='" + str(_itemName) + "'")
        x=len(_itemName)
        mlist=[]
        itemUOQ=view_v_item_qty_33_1_c.objects.values().filter(item_name=_itemName).values_list('qty_measure_name')
        mlist=list(itemUOQ)
        print('item:' + _itemName)
        uoq=''
        if len(itemUOQ)>0:
            uoq=itemUOQ[0]
        else:
            uoq=uoq
        return uoq

        #alist=[num for index,num in enumerate(mlist) if mlist[index][0]==_itemName]
        #alist=[num for index,num in enumerate(itemUOQ) if itemUOQ[index][0]==_itemName]

        #count = len(mlist)
        #filtered = [num for index,num in mlist if num[index]['item_name']==_itemName]
        #.filter(item_name=_itemName)


        #uoq=''
        #if len(alist)>0:
            #uoq=alist[0]
        #else:
            #uoq=uoq

        #return uoq


    def addItemNameToDb(self,_itemName):
       #
        item_=item(name=_itemName,status='Active')
        item_.save()
        return 'Item Successful Saved'
            #all_shops.save()
            #msg=''
            #msg=request.POST['shopName']
            #return JsonResponse({'statuss':msg})
            #all_shops=shop(name='headache')
            #all_shops.save()

            #
    def addStockInToShopMultiple(self,itemDescId,quantity,uoq,dtpStockInToShopDate,shopName,warehouseName):
        id=0
        print('xoxo') #CEO
        msg=''
        msg=self.addStockInToShopMultipleToDb(itemDescId,quantity,uoq,shopName,dtpStockInToShopDate,warehouseName)
        ###

        return 'Stock In To Shop was successfully Saved'

    def addStockInToWarehouseMultiple(self,itemDescId,quantity,uoq,dtpStockInToShopDate,warehouseName):
        id=0
        print('xoxo') #CEO
        msg=''
        msg=self.addStockInToWarehouseMultipleToDb(itemDescId,quantity,uoq,warehouseName,dtpStockInToShopDate)
        ###

        return 'Stock In To Warehouse was successfully Saved'

    def getWarehouseId(self,_warehouseName):
        x=0
        y=warehouse_inv.objects.values().filter(name=_warehouseName,status='Active')
        z=y[0]['id']
        return z

    def getShopId(self,_shopName):
        x=0
        y=shop.objects.values().filter(name=_shopName,status='Active')
        print("yyy=" + str(y))
        #.values_list('id')
        z=y[0]['id']
        #(Max('id'))['id__max']
        return z

    def addStockInToShopMultipleToDb(self,_itemDescId,_itemQuantity,_itemUOQ,_shopName,_stockInDate,_warehouseName):
        shopId=0
        shopId=self.getShopId(_shopName)
        inv=stock_in_to_shop_details(
        item_desc_id_id=_itemDescId,quantity=_itemQuantity,
        uoq=_itemUOQ,shop_id_id=shopId,status='Active',stock_in_date=_stockInDate
        )
        inv.save()
        ###shop.objects.get(id=shopId)
        stockInToShopDetailsId=stock_in_to_shop_details.objects.values().aggregate(Max('id'))['id__max']
        warehouseId=0
        todayDateStr=self.getTodayDate()
        todayDateStr=todayDateStr + " " + self.getTodayTime()
        print("whn=" + _warehouseName)
        if _warehouseName=="":
            inv_=purchases_store(item_desc_id_id=_itemDescId,
            purchases_id_id=stockInToShopDetailsId,quantity=_itemQuantity,
            unit_price=0,uoq=_itemUOQ,status='OUT', category="STOCK IN TO SHOPS")
            inv_.save()
            ###
        else:
            warehouseId=self.getWarehouseId(_warehouseName)
            inv_=stock_in_to_warehouse_details(item_desc_id_id=_itemDescId,
            warehouse_inv_id_id=warehouseId,stock_in_date=todayDateStr,
            stock_in_to_shop_details_id_id=stockInToShopDetailsId,quantity=_itemQuantity,
            uoq=_itemUOQ,status='OUT')
            inv_.save()
            ### REVERSE

        print("xo neil")

        return ''


    def addStockInToWarehouseMultipleToDb(self,_itemDescId,_itemQuantity,_itemUOQ,_warehouseName,_stockInDate):
        warehouseId=0
        warehouseId=self.getWarehouseId(_warehouseName)
        inv=stock_in_to_warehouse_details(
        item_desc_id_id=_itemDescId,quantity=_itemQuantity,
        uoq=_itemUOQ,warehouse_inv_id_id=warehouseId,status='IN',stock_in_date=_stockInDate
        )
        inv.save()
        ###shop.objects.get(id=shopId)
        stockInToWarehouseDetailsId=stock_in_to_warehouse_details.objects.values().aggregate(Max('id'))['id__max']

        inv_=purchases_store(item_desc_id_id=_itemDescId,
        purchases_id_id=stockInToWarehouseDetailsId,quantity=_itemQuantity,
        unit_price=0,uoq=_itemUOQ,status='OUT',category="WAREHOUSE")
        inv_.save()
        print("xo neil")
        return ''


    ###

    def getItemCategoryId(self,_categoryName):
        inv=ext_category.objects.values().filter(name=_categoryName)
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['id']
            ####
        else:
            y=y
        return y

    def lookIfItemCategoryNameExists(self,_categoryName):
        inv=ext_category.objects.values().filter(name=_categoryName)
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['id']
            ####
        else:
            y=y
        return y


    def insertIntoItemCategory(self,_categoryName):
        inv=ext_category(name=_categoryName, status='Active')
        inv.save()

    def addNewItemCategory(self, _categoryName):
        _categoryName=gen.removeWhiteSpaces(_categoryName)
        categoryId=0
        categoryId=self.lookIfItemCategoryNameExists(_categoryName)
        #newUserCategories=userCategories()
        #supplierId=newUserCategories.getSupplierId(_supplierName)
        if categoryId==0:
            self.insertIntoItemCategory(_categoryName)
            msg='Item Category was successfully Added'
        else:
            msg='Item Category already Exists'
        return msg



    def addNewPurchasesExt(self,_itemName,_itemModel,_itemSpecs,_itemQuantity,_itemUOQ,_itemUnitPrice,_dtpPurchasesDate, _batchNumber):
        id=0
        _itemName=gen.removeWhiteSpaces(_itemName)
        _batchNumber=gen.removeWhiteSpaces(_batchNumber)

        id=self.insertToPurchases(_dtpPurchasesDate,_batchNumber)
        self.insertToPurchasesDetailsExt(_itemName,_itemModel,_itemSpecs,_itemQuantity,_itemUOQ,_itemUnitPrice,id)
        ###
        return 'Purchase was successfully Saved'

    ###order_from_supplier
    def insertToPurchasesDetailsExt(self,_itemName,_itemModel,_itemSpecs,_itemQuantity,_itemUOQ,_itemUnitPrice,_purchasesId):
            y=0
            self.insertIntoItemBrand(_itemName,_itemModel)
            self.insertIntoItemSize(_itemName,_itemSpecs)
            #print("2:::_itemSpecs=" + str(_itemSpecs))
            itemDescId=self.insertItemBrandAndSizeIntoItemDesc(_itemModel,_itemName,_itemSpecs)

            inv_=purchases_store(item_desc_id_id=itemDescId,purchases_id_id=_purchasesId,quantity=_itemQuantity,
            unit_price=_itemUnitPrice,uoq=_itemUOQ,status='IN', category="PURCHASES")
            inv_.save()

            inv=purchases_details(item_desc_id_id=itemDescId,purchases_id_id=_purchasesId,quantity=_itemQuantity,
            unit_price=_itemUnitPrice,uoq=_itemUOQ,status='Active')
            inv.save()

            z=0
            _status=False
            while _status==False:
                z=self.lookIfItemStoredInPurchasesStore( _purchasesId)
                if z>0:
                    _status=True

            print(str(":::STATUS STATUS:::"))
            catId=self.getItemCategoryId(_itemModel)
            inv=item_desc_ext_category(
            ext_category=ext_category.objects.get(id=catId),
            item_desc=item_desc.objects.get(id=itemDescId),
            status='Active')
            inv.save()

            return 'Purchases was successful'
            #inv=purchases_details(_itemName,_itemModel,_itemSpecs,_itemQuantity,_itemUOQ,_itemUnitPrice)
            #zzzurchases was successful'

            ###

    def addNewOrderExt(self,_supplierName,_itemName,_itemModel,_itemSpecs,_itemQuantity,_itemUOQ,_itemUnitPrice,_orderDate):
        id=0
        _supplierName=gen.removeWhiteSpaces(_supplierName)
        _itemName=gen.removeWhiteSpaces(_itemName)
        #_batchNumber=gen.removeWhiteSpaces(_batchNumber)

        #id=self.insertToPurchases(_dtpPurchasesDate,_batchNumber)
        self.insertToOrderFromSupplierExt(_supplierName,_itemName,_itemModel,_itemSpecs,_itemQuantity,_itemUOQ,_itemUnitPrice,_orderDate)
        ###
        return 'Order was successfully Saved'

    ###order_from_supplier
    def insertToOrderFromSupplierExt(self,_supplierName,_itemName,_itemModel,_itemSpecs,_itemQuantity,_itemUOQ,_itemUnitPrice,_orderDate):
            y=0
            self.insertIntoItemBrand(_itemName,_itemModel)
            self.insertIntoItemSize(_itemName,_itemSpecs)
            #print("2:::_itemSpecs=" + str(_itemSpecs))
            myUoq=uoq() ##extCategoryId,itemDescId
            itemId=myUoq.getItemId(_itemName) ###_itemBrand,_itemName,_itemSize
            itemDescId=self.lookForItemBrandInItemDesc(_itemModel,_itemName,_itemSpecs)###getItemExtCategoryIdFromDb(_itemModel)
            itemExtCategoryId=self.getExtCategoryIdFromDb(_itemModel)
            itemDescExtCategoryId=self.getItemDescExtCategoryIdFromDb(itemExtCategoryId,itemDescId)
            ###FERNANDES
            # inv_=purchases_store(item_desc_id_id=itemDescId,purchases_id_id=_purchasesId,quantity=_itemQuantity,
            # unit_price=_itemUnitPrice,uoq=_itemUOQ,status='IN', category="PURCHASES")
            # inv_.save()


            _supplierName=gen.removeWhiteSpaces(_supplierName)
            supplierId=0
            newUserCategories=userCategories()
            supplierId=newUserCategories.getSupplierId(_supplierName)

            inv=order_from_supplier(
            supplier=supplier.objects.get(id=supplierId),
            item=item.objects.get(id=itemId),
            item_desc_ext_category=item_desc_ext_category.objects.get(id=itemDescExtCategoryId),
            quantity=_itemQuantity,
            price=_itemUnitPrice,uoq=_itemUOQ,
            order_date=_orderDate,
            status='Active')
            inv.save()

            # z=0
            # _status=False
            # while _status==False:
            #     z=self.lookIfItemStoredInPurchasesStore( _purchasesId)
            #     if z>0:
            #         _status=True

            print(str(":::STATUS STATUS:::"))
            catId=self.getItemCategoryId(_itemModel)
            inv=item_desc_ext_category(
            ext_category=ext_category.objects.get(id=catId),
            item_desc=item_desc.objects.get(id=itemDescId),
            status='Active')
            inv.save()

            return 'Purchases was successful'
            #inv=purchases_details(_itemName,_itemModel,_itemSpecs,_itemQuantity,_itemUOQ,_itemUnitPrice)
            #zzzurchases was successful'

            ###



    def getItemDescsFromItemCategory(self, itemCategory): ###BITCOIN
        itemCategory=gen.removeWhiteSpaces(itemCategory)

        itemUOQ=''
        #print("itemname='" + str(_itemName) + "'")
        #x=len(_itemName)

        mlist=[]
        #itemUOQ=view_v_item_qty_33_1_c.objects.values().filter(item_name=_itemName)
        #.values_list('qty_measure_name')
        xx=view_v_item_desc_with_ext_category_01.objects.values().filter(category_name=itemCategory)###.values_list('qty_measure_name')
        #mlist=list(itemUOQ)
        iList=[]
        x=0
        iStr=''#'{['
        for a in xx:
            y=0
            iStr+='{"descName":"' + a['desc_name'].replace(":","") + '",'
            iStr+='"itemDescId":"' + str(a['item_desc_id']) + '"},'
            myDict={
            "sno": x+1,
            "descName":a['desc_name'] , "categoryName":a['category_name'] , "itemId":str(a['item_id']),
            "itemDescId": str(a['item_desc_id'])
            }
            iList.append(myDict)
            x=x+1
        x=0
        x=len(xx)
        if x==0:
            iStr='[]'
        else:
            iStr='[' + iStr[0:(len(iStr)-1)]
            iStr+=']'
        print(str(iList))
        print(str(iStr))
        x=0

        return iStr
        ###return uoq


###

# for a in inv_stockintowarehouses:
#     y=0
#     myDict={
#     "sno": x+1,
#     "descName":a['desc_name'] , "stockInDate":str(a['stock_in_date']),
#     "quantity": str(a['quantity']),"uoq": a['uoq'],
#     "warehouseName": str(a['warehouse_name'])
#     }
#     iList.append(myDict)
#     x=x+1
#
# return iList
