from datetime import datetime

from inventory.models import (
count_tokens, item_desc,view_v_item_desc_1,
account_category,account,users,login_category,
user_password, view_v_user_login_details_1_a,
user_login_category,view_v_item_desc_with_uoq_1,
company,
)
from django.db.models import Max
###from inventory.purchases.purchasesFunctions import purchases
from inventory.general.general import general
###from purchases.purchasesFunctions import purchasesCl
from inventory.userCategoryFunctions import userCategories


newCategory=userCategories()
#newPurchases= purchases()
newGeneral= general()

class systemUsersC:

    systemUsers_init=''
        #return 0
    def getItemUoqAndItemNames(self):
        inv=view_v_item_desc_with_uoq_1.objects.values()
        jStr='{"items":['
        y=0
        for a in inv:
            jStr+='{"itemDescId":"' + str(a['item_desc_id']) + '",'
            jStr+='"itemDescName":"' + a['desc_name'] + '",'
            jStr+='"itemUoq":"' + a['uoq'] + '",'
            jStr+='"itemSingleUnit":"' + str(a['single_unit']) + '"'
            if y+1>=len(inv):
                jStr+='}'
            else:
                jStr+='},'
            y=y+1
        jStr+=']}'
        return jStr


    def insertIntoUsersDb(self, _userName, _userEmail):
        inv=users(
        username= _userName,
        useremail= _userEmail,
        status='Active'
        )
        inv.save()
        userId=self.getUsersId(_userName, _userEmail)
        return userId

    def insertIntoLoginCategoryDb(self, _usersId, _userCategoryId):
        inv=user_login_category(
        users_id= _usersId,
        login_category_id= _userCategoryId,
        status='Active'
        )
        inv.save()
        return 'OK'


    def insertIntoUsersPasswordDb(self, _usersId, _userPassword, _issueDate, _expireDate):
        inv=user_password(
        users_id=_usersId,
        password= _userPassword,
        issue_date=_issueDate,
        expire_date=_expireDate,
        status='Active'
        )
        inv.save()
        return ''
    
    def getHourNow(self):
        hn=''
        hn=str(datetime.now().hour)

        if len(hn)==1:
            hn='0' + hn
       
        return hn
    
    def getDateAndHour(self):
        xhn=''
        xn=''
        xn=newGeneral.getTodayDate()
        hn=self.getHourNow()
        xhn=xn + '_' + hn
        return xhn

    def tryLogin(self,request, _userName, _userPassword, _userEmail):
        msg=''
        y=0
        x=0
        z=0
        a=0
        y=self.getUsersCredentials(_userName, _userPassword, _userEmail)
        if y>0:
            msg="success"
            cn=''  ###company name
            cn=self.getUsersCompanyNo(_userName, _userPassword, _userEmail)
            hn='' ###hour now
            hn=self.getHourNow()
            nn=''
            xn=''
            ab=''
            ab=newCategory.getRandomTextSess()
            xn=self.getUsersCompanyNo( _userName, _userPassword, _userEmail)
            nn=self.getDateAndHour()
            ##nn=str(self.getUsersId(_userName, _userEmail)) + '#'
            sessname=str(y) + "#" + str(xn) + "$" + str(nn) + "%" + ab
            ###getDateAndHour
            request.session[sessname]="Active"
            request.session['log_session']=sessname
            print("sess_name=" + sessname)
            msg="success:" + sessname
            request.session['userNameXx']=_userName
            request.session['userNameXxY']=sessname
        else:
            request.session['userNameXx']=''
            msg="Failed to login"
            x=self.checkEmailForLogin(_userEmail)
            if x==0:
                msg+=" Incorrect Email "
            z=self.checkPasswordForLogin(_userPassword)
            if z==0:
                msg+=" Incorrect Password "
            a=self.checkUserNameForLogin(_userName)
            if a==0:
                msg+=" Incorrect User Name "
        return msg
    
    def getUserIdFromSession(self,sessionStr):
        x=0
        x=sessionStr.index("#")
        sess=''
        sess=sessionStr[0:x]
        return sess

    def getCompanyIdFromSession(self,sessionStr):
        z=0
        z=self.getCompanyNoFromSession(sessionStr)
        inv=company.objects.values().filter(company_no=z)
        
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['id']
        else:
            y=y
        return y
        
    def getCompanyNoFromSession(self,sessionStr):
        x=0
        x=sessionStr.index("#")
        y=0
        y=sessionStr.index("$")
        sess=''
        sess=sessionStr[x+1:y]
        return sess
        
        

    def checkUserNameForLogin(self, _userName):
        inv=view_v_user_login_details_1_a.objects.values().filter(username=_userName)
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['users_id']
        else:
            y=y
        return y

    def checkPasswordForLogin(self, _userPassword):
        inv=view_v_user_login_details_1_a.objects.values().filter(password=_userPassword)
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['users_id']
        else:
            y=y
        return y

    def checkEmailForLogin(self, _userEmail):
        inv=view_v_user_login_details_1_a.objects.values().filter(useremail=_userEmail)
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['users_id']
        else:
            y=y
        return y

    def getUsersCredentials(self, _userName, _userPassword, _userEmail):
        inv=view_v_user_login_details_1_a.objects.values().filter(username=_userName, useremail=_userEmail,password=_userPassword)
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['users_id']
        else:
            y=y
        return y

    def getUsersCompanyId(self, _userName, _userPassword, _userEmail):
        inv=users.objects.values().filter(username=_userName, useremail=_userEmail,status='Active')
        x=list(inv)
        y=0
        cn=''
        if len(x)>0:
            y=x[0]['company_id']
        else:
            y=y
        return y

    def getUsersCompanyNo(self, _userName, _userPassword, _userEmail):
        z=0
        z=self.getUsersCompanyId( _userName, _userPassword, _userEmail)
        inv=company.objects.values().filter(id=z,status='Active')
        x=list(inv)
        y=0
        cn=''
        if len(x)>0:
            cn=x[0]['company_no']
        else:
            cn=cn
        return cn

    def getCompanyIdFromCompanyNo(self, companyNo):
        z=0
        ###z=self.getUsersCompanyId( _userName, _userPassword, _userEmail)
        inv=company.objects.values().filter(company_no=companyNo,status='Active')
        x=list(inv)
        y=0
        cn=''
        if len(x)>0:
            y=x[0]['id']
        else:
            y=y
        return y

    def getUsersId(self, _userName, _userEmail):
        inv=users.objects.values().filter(username=_userName,useremail=_userEmail, status='Active')
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['id']
        else:
            y=y
        return y


    def saveNewUser(self, _userCategory, _userName, _userEmail, _userPassword, _issueDate, _expireDate):
        accountId=0
        y=0
        msg=''
        userId=0
        y=self.getUsersId(_userName, _userEmail)
        if y>0:
            msg='User Already Exists'
        else:
            userCategoryId=self.getUserCategoryId(_userCategory)
            userId=self.insertIntoUsersDb(_userName, _userEmail)
            self.insertIntoUsersPasswordDb(userId, _userPassword, _issueDate, _expireDate)
            self.insertIntoLoginCategoryDb(userId, userCategoryId)
            msg='User was successfully saved'
        #y=self.insertNewExpensesToDb(accountId, _amount, _transDate,_details)
        return msg

    def getUserCategoryId(self, _userCategory):
        inv=login_category.objects.values().filter(name=_userCategory, status='Active')
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['id']
        else:
            y=y
        return y
