
from inventory.models import (
item,item_size,item_brand,item_desc,inv_no_settings,
item_inv_no_settings,qty_measure,qty_measure_data,item_measures,
t_purchases,purchases_details,
item_measures,t_purchases,warehouse_inv,
login_category,roles,category_roles,users,user_password,user_login_category,
login_category,warehouse_manager,shop,shop_manager,
roles,category_roles,roles,warehouse,warehouse_manager,
view_v_item_qty_33_1_c,login_category,
category_shop,
)
from django.db.models import Max
from inventory.uoqFunctions import uoq
from inventory.userCategoryFunctions import userCategories

class warehouses:

    def insertIntoShopManager(self,_shopId,_userNameId,_status):
        inv=shop_manager(
        shop_id_id=_shopId,users_id_id=_userNameId,status='Active')
        inv.save()
        y=0
        y=users.objects.values().aggregate(Max('id'))['id__max']
        return y

    def insertIntoWarehouseManager(self,_warehouseId,_userNameId,_status):
        inv=warehouse_manager(
        warehouse_id_id=_warehouseId,users_id_id=_userNameId,status='Active')
        inv.save()
        y=0
        y=users.objects.values().aggregate(Max('id'))['id__max']
        return y

    #
    def lookIfUserExistsInShopManagerDb(self,_userName):
        userId=0
        newUserCategory=userCategories()
        userId=newUserCategory.getUserId(_userName)
        inv=shop_manager.objects.values().filter(users_id_id=userId,status='Active')
        x=0
        x=len(list(inv))
        print('inv=' + str(inv) + ' : len=' + str(x))
        if x>0:
            x=inv[0]['id']
        else:
            x=0
            #inventory_warehouse_manager
        return x
        ###

    def lookIfUserExistsInWarehouseManagerDb(self,_userName):
        userId=0
        newUserCategory=userCategories()
        userId=newUserCategory.getUserId(_userName)
        inv=warehouse_manager.objects.values().filter(users_id_id=userId,status='Active')
        x=0
        x=len(list(inv))
        print('inv=' + str(inv) + ' : len=' + str(x))
        if x>0:
            x=inv[0]['id']
        else:
            x=0
            #inventory_warehouse_manager
        return x
        ###
    #
    def lookIfShopExistsInShopManagerDb(self,_shopName):
        shopId=0
        shopId=self.getShopId(_shopName)
        inv=shop_manager.objects.values().filter(shop_id_id=shopId,status='Active')
        x=0
        x=len(list(inv))
        print('inv=' + str(inv) + ' : len=' + str(x))
        if x>0:
            x=inv[0]['id']
        else:
            x=0
            #inventory_warehouse_manager
        return x
        ###

    def lookIfWarehouseExistsInWarehouseManagerDb(self,_warehouseName):
        warehouseId=0
        warehouseId=self.getWarehouseId(_warehouseName)
        inv=warehouse_manager.objects.values().filter(warehouse_id_id=warehouseId,status='Active')
        x=0
        x=len(list(inv))
        print('inv=' + str(inv) + ' : len=' + str(x))
        if x>0:
            x=inv[0]['id']
        else:
            x=0
            #inventory_warehouse_manager
        return x
        ###

    #
    def lookIfShopManagerExists(self,_shopName,_userName,_status):
        msg=''
        userId=0
        newUserCategory=userCategories()
        userId=newUserCategory.getUserId(_userName)
        shopId=0
        shopId=self.getShopId(_shopName)
        inv=shop_manager.objects.values().filter(shop_id_id=shopId,users_id_id=userId,status='Active')
        x=0
        x=len(list(inv))
        print('inv=' + str(inv) + ' : len=' + str(x))
        if x>0:
            x=0
            x=inv[0]['id']
        else:
            x=0
            #inventory_warehouse_manager
        return x
        ###


    def lookIfWarehouseManagerExists(self,_warehouseName,_userName,_status):
        msg=''
        userId=0
        newUserCategory=userCategories()
        userId=newUserCategory.getUserId(_userName)
        warehouseId=0
        warehouseId=self.getWarehouseId(_warehouseName)
        inv=warehouse_manager.objects.values().filter(warehouse_id_id=warehouseId,users_id_id=userId,status='Active')
        x=0
        x=len(list(inv))
        print('inv=' + str(inv) + ' : len=' + str(x))
        if x>0:
            x=0
            x=inv[0]['id']
        else:
            x=0
            #inventory_warehouse_manager
        return x
        ###
    #

    def addNewShopManager(self,_shopName,_userName,_status):
        if _shopName[0]==' ':
            _shopName=_shopName[1:len(_shopName)]
        if _userName[0]==' ':
            _userName=_userName[1:len(_userName)]
        msg=''
        shopManagerId=0
        shopManagerId=self.lookIfShopManagerExists(_shopName,_userName,_status)
        shopId=0
        shopId=self.lookIfShopExistsInShopManagerDb(_shopName)
        userId=0
        userId=self.lookIfUserExistsInShopManagerDb(_userName)
        newUserCategory=userCategories()
        if shopManagerId==0 and shopId==0 and userId==0:
            x=0
            userId=0
            userId=newUserCategory.getUserId(_userName)
            print('userId : ' + str(userId))
            shopId=0
            shopId=self.getShopId(_shopName)
            print('wareId : ' + str(shopId))
            x=self.insertIntoShopManager(shopId,userId,_status)
            msg='Shop Manager was successfully Added'
            ###
        elif shopManagerId==0 and shopId>0 and userId==0:
            self.updateshopFromShopManager(shopId)
            userId=0
            userId=newUserCategory.getUserId(_userName)
            print('userId : ' + str(userId))
            print('wareId : ' + str(shopId))
            x=self.insertIntoShopManager(shopId,userId,_status)
            msg='Shop Manager was successfully Updated'
            ###
        elif shopManagerId==0 and shopId==0 and userId>0:
            self.updateUserFromShopManager(userId)
            print('userId : ' + str(userId))
            shopId=0
            shopId=self.getShopId(_shopName)
            print('wareId : ' + str(shopId))
            x=self.insertIntoShopManager(shopId,userId,_status)
            msg='Shop Manager was successfully Updated'
            ###
        elif shopManagerId>0 and userId==0:
            self.updateShopFromShopManager(shopId)
            userId=0
            userId=newUserCategory.getUserId(_userName)
            x=self.insertIntoShopManager(shopId,userId,_status)
            msg='Shop Manager was successfully Updated'
            ###
        else:
            msg='Shop Manager Already Exists'
            ###
        return msg
        ###
    def addNewWarehouseManager(self,_warehouseName,_userName,_status):
        if _warehouseName[0]==' ':
            _warehouseName=_warehouseName[1:len(_warehouseName)]
        if _userName[0]==' ':
            _userName=_userName[1:len(_userName)]
        msg=''
        warehouseManagerId=0
        warehouseManagerId=self.lookIfWarehouseManagerExists(_warehouseName,_userName,_status)
        warehouseId=0
        warehouseId=self.lookIfWarehouseExistsInWarehouseManagerDb(_warehouseName)
        userId=0
        userId=self.lookIfUserExistsInWarehouseManagerDb(_userName)
        newUserCategory=userCategories()
        if warehouseManagerId==0 and warehouseId==0 and userId==0:
            x=0
            userId=0
            userId=newUserCategory.getUserId(_userName)
            print('userId : ' + str(userId))
            warehouseId=0
            warehouseId=self.getWarehouseId(_warehouseName)
            print('wareId : ' + str(warehouseId))
            x=self.insertIntoWarehouseManager(warehouseId,userId,_status)
            msg='Warehouse Manager was successfully Added'
            ###
        elif warehouseManagerId==0 and warehouseId>0 and userId==0:
            self.updateWarehouseFromWarehouseManager(warehouseId)
            userId=0
            userId=newUserCategory.getUserId(_userName)
            print('userId : ' + str(userId))
            print('wareId : ' + str(warehouseId))
            x=self.insertIntoWarehouseManager(warehouseId,userId,_status)
            msg='Warehouse Manager was successfully Updated'
            ###
        elif warehouseManagerId==0 and warehouseId==0 and userId>0:
            self.updateUserFromWarehouseManager(userId)
            print('userId : ' + str(userId))
            warehouseId=0
            warehouseId=self.getWarehouseId(_warehouseName)
            print('wareId : ' + str(warehouseId))
            x=self.insertIntoWarehouseManager(warehouseId,userId,_status)
            msg='Warehouse Manager was successfully Updated'
            ###
        elif warehouseManagerId>0 and userId==0:
            self.updateWarehouseFromWarehouseManager(warehouseId)
            userId=0
            userId=newUserCategory.getUserId(_userName)
            x=self.insertIntoWarehouseManager(warehouseId,userId,_status)
            msg='Warehouse Manager was successfully Updated'
            ###
        else:
            msg='Warehouse Manager Already Exists'
            ###
        return msg
        ###
    def updateUserFromWarehouseManager(self,_userId):
        inv=warehouse_manager.objects.filter(
        users_id_id=_userId,status='Active'
        ).update(status='InActive')
        ###cold fusion
        ###

    #
    def updateShopFromShopManager(self,_shopId):
        inv=shop_manager.objects.filter(
        shop_id_id=_shopId,status='Active'
        ).update(status='InActive')
        ###cold fusion
        ###

    def updateWarehouseFromWarehouseManager(self,_wareHouseId):
        inv=warehouse_manager.objects.filter(
        warehouse_id_id=_wareHouseId,status='Active'
        ).update(status='InActive')
        ###cold fusion
        ###

    def updateFromWarehouse(self,_storesName,_storesAddress,_storesTelephone,_status,companyId):
        msg=''
        inv=warehouse_inv.objects.filter(
        name=_storesName,status='Active',company_id=companyId
        ).update(address=_storesAddress,telephone=_storesTelephone,status=_status)
        msg='Warehouse successfully updated'
        #

    #
    def updateFromShop(self,_shopName,_shopAddress,_shopTelephone,_status,_categoryId,companyId):
        msg=''
        inv=shop.objects.filter(
        name=_shopName,status='Active',company_id=companyId
        ).update(address=_shopAddress,telephone=_shopTelephone,status=_status,
        category_shop=category_shop.objects.get(id=_categoryId))
        msg='Shop successfully updated'
        #

    def insertIntoUserPassword(self,_userId,_userPassword,_issueDate,_expireDate):
        inv=user_password(password=_userPassword,issue_date=_issueDate,expire_date=_expireDate,
        users_id_id=_userId,status='Active')
        inv.save()
        #y=0
        #y=users.objects.values().aggregate(Max('id'))['id__max']
        #return y

    def insertIntoUsers(self,_userName,_userEmail):
        inv=users(username=_userName,useremail=_userEmail,status='Active')
        inv.save()
        y=0
        y=users.objects.values().aggregate(Max('id'))['id__max']
        return y

    def getUserEmail(self,_userEmail):
        msg=''
        inv=users.objects.values().filter(useremail=_userEmail,status='Active')
        x=0
        x=len(list(inv))
        #print('inv=' + str(inv) + ' : len=' + str(x))
        if x>0:
            z=inv[0]['id']
        else:
            z=0
        return z #msg

    def getWarehouseId(self,_warehouseName,companyId):
        msg=''
        inv=warehouse_inv.objects.values().filter(company_id=companyId, name=_warehouseName,status='Active')
        x=0
        x=len(list(inv))
        #print('inv=' + str(inv) + ' : len=' + str(x))
        if x>0:
            z=inv[0]['id']
        else:
            z=0
        return z #msg


    #
    def getShopId(self,_shopName,companyId):
        msg=''
        inv=shop.objects.values().filter(name=_shopName,status='Active',company_id=companyId)
        x=0
        x=len(list(inv))
        #print('inv=' + str(inv) + ' : len=' + str(x))
        if x>0:
            z=inv[0]['id']
        else:
            z=0
        return z #msg

    def getCategoryShopId(self,categoryName):
        print("categoryName='" + categoryName + "'")
        msg=''
        inv=category_shop.objects.values().filter(name=categoryName,status='Active')
        x=0
        x=len(list(inv))
        #print('inv=' + str(inv) + ' : len=' + str(x))
        if x>0:
            z=inv[0]['id']
        else:
            z=0
        return z #msg


    def getWarehouseId_(self,_warehouseName):
        msg=''
        inv=warehouse_inv.objects.values().filter(name=_warehouseName,status='Active')
        x=0
        x=len(list(inv))
        #print('inv=' + str(inv) + ' : len=' + str(x))
        if x>0:
            z=inv[0]['id']
        else:
            z=0
        return z #msg


    def getUserCategoryId(self,_userCategory):
        msg=''
        inv=login_category.objects.values().filter(name=_userCategory,status='Active')
        x=0
        x=len(list(inv))
        z=0
        #print('inv=' + str(inv) + ' : len=' + str(x))
        if x>0:
            z=inv[0]['id']
        else:
            z=0
        return z #msg

    #
    def insertIntoShop(self,_shopName,_shopAddress,_shopTelephone,_status,_categoryId, companyId):
        msg=''
        inv=shop(name=_shopName,address=_shopAddress,telephone=_shopTelephone,status=_status,
        category_shop=category_shop.objects.get(id=_categoryId),company_id=companyId)
        inv.save()
        msg='Shop successfully saved'


    def insertIntoWarehouseOld(self,_storesName,_storesAddress,_storesTelephone,_status):
        msg=''
        inv=warehouse(name=_storesName,address=_storesAddress,telephone=_storesTelephone,status=_status)
        inv.save()
        msg='Warehouse successfully saved'
    
    def insertIntoWarehouse(self,_storesName,_storesAddress,_storesTelephone,_status,companyId):
        msg=''
        inv=warehouse_inv(name=_storesName,address=_storesAddress,telephone=_storesTelephone,status=_status,company_id=companyId)
        inv.save()
        msg='Warehouse successfully saved'

    def addNewWarehouse1(self,_storesName,_storesAddress,_storesTelephone,_status): #1
        warehouseId=0
        warehouseId=self.getWarehouseId(_storesName)
        x=0
        msg=''
        if warehouseId>0:
            self.updateFromWarehouse(_storesName,_storesAddress,_storesTelephone,_status)
            x=x
            msg='Warehouse already exists'
        else:
            msg=self.insertIntoWarehouse(_storesName,_storesAddress,_storesTelephone,_status)
            x=x
        msg='Warehouse Successfully saved'
        return msg

    def addNewWarehouse4(self,_storesName,_storesAddress,_storesTelephone,_status):
        warehouseId=0
        warehouseId=self.getWarehouseId(_storesName)
        x=0
        msg=''
        if warehouseId>0:
            self.updateFromWarehouse(_storesName,_storesAddress,_storesTelephone,_status)
            x=x
            msg='Warehouse already exists'
        else:
            msg=self.insertIntoWarehouse(_storesName,_storesAddress,_storesTelephone,_status)
            x=x
        msg='Warehouse Successfully saved'
        return msg

    def addNewWarehouse(self,_storesName,_storesAddress,_storesTelephone,_status,companyId): #3
        warehouseId=0
        warehouseId=self.getWarehouseId(_storesName,companyId)
        x=0
        msg=''
        if warehouseId>0:
            self.updateFromWarehouse(_storesName,_storesAddress,_storesTelephone,_status,companyId)
            x=x
            msg='Warehouse already exists'
        else:
            msg=self.insertIntoWarehouse(_storesName,_storesAddress,_storesTelephone,_status,companyId)
            x=x
        msg='Warehouse Successfully saved'
        return msg

    def addNewShop(self,_shopName,_shopAddress,_shopTelephone,_status,_shopCategory,companyId):
        shopId=0
        shopId=self.getShopId(_shopName,companyId)
        categoryId=0
        categoryId=self.getCategoryShopId(_shopCategory)
        ###print("categoryId=" + str(categoryId))
        ###print("categoryName='" + _shopCategory + "'")
        x=0
        msg=''

        if shopId>0:
            self.updateFromShop(_shopName,_shopAddress,_shopTelephone,_status,categoryId)
            x=x
            msg='Shop already exists'
        else:
            v_shops=shop.objects.values().filter(status='Active').order_by('name')
            v_len=len(list(v_shops))
            if v_len>2:
                msg='Number of shops exceeds 2 shops'
                ###
            else:
                msg=self.insertIntoShop(_shopName,_shopAddress,_shopTelephone,_status,categoryId,companyId)
                x=x
                msg='Shop Successfully saved'
                ###
        return msg

    def addNewWarehouse2(self,_warehouseName,_warehouseAddress,_warehouseTelephone,_status): #2
        warehouseId=0
        warehouseId=self.getWarehouseId(_warehouseName)
        x=0
        msg=''

        if warehouseId>0:
            self.updateFromwarehouse(_warehouseName,_warehouseAddress,_warehouseTelephone,_status)
            x=x
            msg='warehouse already exists'
        else:
            v_warehouses=warehouse.objects.values().filter(status='Active').order_by('name')
            v_len=len(list(v_warehouses))
            if v_len>2:
                msg='Number of warehouses exceeds 2 warehouses'
                ###
            else:
                msg=self.insertIntowarehouse(_warehouseName,_warehouseAddress,_warehouseTelephone,_status)
                x=x
                msg='warehouse Successfully saved'
                ###
        return msg

    def editWarehouse(self,_warehouseName,_warehouseAddress,_warehouseTelephone,_status,warehouseId): #1
        print("warehouseId=" + str(warehouseId))
        warehouseId=int(warehouseId)
        #warehouseId=self.getShopId(_warehouseName)
        x=0
        msg=''

        if warehouseId>0:
            inv=warehouse_inv.objects.filter(
            id=warehouseId
            ).update(name=_warehouseName,address=_warehouseAddress,telephone=_warehouseTelephone,status=_status)
            x=x
            msg='Warehouse successfully Updated'
        else:
            v_warehouses=warehouse_inv.objects.values().filter(status='Active').order_by('name')
            v_len=len(list(v_warehouses))
            if v_len>2:
                msg='Number of warehouses exceeds 2 warehouses'
                ###
            else:
                #msg=self.insertIntoShop(_warehouseName,_warehouseAddress,_warehouseTelephone,_status)
                x=x
                msg='Warehouse failed to Update'
                ###
        return msg


    def editShop(self,_shopName,_shopAddress,_shopTelephone,_status,shopId):
        print("shopId=" + str(shopId))
        shopId=int(shopId)
        #shopId=self.getShopId(_shopName)
        x=0
        msg=''

        if shopId>0:
            inv=shop.objects.filter(
            id=shopId
            ).update(name=_shopName,address=_shopAddress,telephone=_shopTelephone,status=_status)
            x=x
            msg='Shop successfully Updated'
        else:
            v_shops=shop.objects.values().filter(status='Active').order_by('name')
            v_len=len(list(v_shops))
            if v_len>2:
                msg='Number of shops exceeds 2 shops'
                ###
            else:
                #msg=self.insertIntoShop(_shopName,_shopAddress,_shopTelephone,_status)
                x=x
                msg='Shop failed to Update'
                ###
        return msg


    def addNewCategoryRoles(self,_userCategory,_userRole):
        if _userRole[0]==' ':
            _userRole=_userRole[1:len(_userRole)]
        ###
        if _userCategory[0]==' ':
            _userCategory=_userCategory[1:len(_userCategory)]

        msg='Category Roles Successfully saved'
        userRoleId=self.getRolesId(_userRole)
        categoryId=self.getLoginCategoryId(_userCategory)
        inv=category_roles.objects.filter(
        login_category_id_id=categoryId,role_id_id=userRoleId,status='Active'
        ).update(status='InActive')
        inv=category_roles(login_category_id_id=categoryId,role_id_id=userRoleId,status='Active')
        inv.save()
        #.objects.values().filter(name=_userRole,status='Active')
        return msg

    def getRolesId(self,_userRole):
        msg=''
        inv=roles.objects.values().filter(name=_userRole,status='Active')
        x=0
        z=0
        x=len(list(inv))
        print('inv=' + str(inv) + ' : len=' + str(x))
        if x>0:
            z=inv[0]['id']
        else:
            z=0
        return z #msg

    def getLoginCategoryId(self,_userCategory):
        msg=''
        inv=login_category.objects.values().filter(name=_userCategory,status='Active')
        x=0
        z=0
        x=len(list(inv))
        print('inv=' + str(inv) + ' : len=' + str(x))
        if x>0:
            z=inv[0]['id']
            #msg='User Category Already exists'
        else:
            z=0
            #msg='User Category does not exist'
        return z #msg

    def addNewUserRole(self,_userRole,_details):
        msg=''
        z=0
        z=self.getRolesId(_userRole)
        if z>0:
            msg='Role Already Exists'
        else:
            inv=roles(name=_userRole,details=_details,status='Active')
            inv.save()
            msg='Role was successfully stored'
        return msg

    def lookIfUserCategoryExists(self,_userCategory):
        msg=''
        inv=login_category.objects.values().filter(name=_userCategory,status='Active')
        x=0
        x=len(list(inv))
        print('inv=' + str(inv) + ' : len=' + str(x))
        if x>0:
            msg='User Category Already exists'
        else:
            msg='User Category does not exist'

        return msg



    def addNewUserCategory(self,_userCategory,_details):
        msg=''
        msg=self.lookIfUserCategoryExists(_userCategory)
        if msg=='User Category Already exists':
            msg=msg
        else:
            inv=login_category(name=_userCategory,details=_details,status='Active')
            inv.save()
            msg='User Category was successfully stored'
        return msg


    def addPurchasesMultiple(self,_itemId,_itemDescId,_itemUnitPrice,_itemQuantity,_itemUOQ,_dtpPurchasesDate):
        id=0
        print('hio')
        msg=''
        id=self.insertToPurchases(_dtpPurchasesDate)
        msg=self.addPuchasesMultipleToDb(_itemDescId,id,_itemQuantity,_itemUnitPrice,_itemUOQ)
        ###
        return msg

    def getItemUoq02(self, _itemName):
        itemUOQ=''
        x=len(_itemName)
        if _itemName[0:1]==' ':
            _itemName=_itemName[1:x]
        mlist=[]
        #itemUOQ=view_v_item_qty_33_1_c.objects.values().filter(item_name=_itemName)
        #.values_list('qty_measure_name')
        itemUOQ=view_v_item_qty_33_1_c.objects.values().filter(item_name=_itemName).values_list('qty_measure_name')
        mlist=list(itemUOQ)
        print(mlist)
        print('item:' + _itemName)
        uoq=''
        if len(itemUOQ)>0:
            uoq=itemUOQ[0]
        else:
            uoq=uoq
        return uoq

        #alist=[num for index,num in enumerate(mlist) if mlist[index][0]==_itemName]
        #alist=[num for index,num in enumerate(itemUOQ) if itemUOQ[index][0]==_itemName]
        #print(alist)
        #count = len(mlist)
        #filtered = [num for index,num in mlist if num[index]['item_name']==_itemName]
        #.filter(item_name=_itemName)
        #print('filtered ' + str(filtered))
        #print(itemUOQ.query)

        #uoq=''
        #if len(alist)>0:
            #uoq=alist[0]
        #else:
            #uoq=uoq

        #return uoq

    def addItemNameToDb(self,_itemName):
       #
        item_=item(name=_itemName,status='Active')
        item_.save()
        return 'Item Successful Saved'
            #all_shops.save()
            #msg=''
            #msg=request.POST['shopName']
            #return JsonResponse({'statuss':msg})
            #all_shops=shop(name='headache')
            #all_shops.save()

            #
